;*** TRANSLATION PROGRAM - BY RAIG RUCE, STARTED 10-UL-93

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:TR"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $40

CHR = $0D
CHRUOTE = $22
MAXINEEN = 2049
TRUE = $FF
FALSE = $00

TRETSCII     = 0
TRSCIIRF   = 1
TRSCIIF     = 2
TRSCIIR     = 3
TRPEEDSCRIPT = 4

TRROM  .BUF 1
TRO    .BUF 1

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

;===MAIN===
ARG = 2
NAME = 4
STRING = 8

MAIN = *
   LDA #TRSCIIRF
   STA TRROM
   LDA #TRETSCII
   STA TRO
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE ENOUGHRGS
   LDA ACERGC+0
   CMP #2
   BCS ENOUGHRGS
   JMP USAGE

ENOUGHRGS = *
   LDA #1
   LDY #0
   STA ARG+0
   STY ARG+1
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE FILERG
   INC ARG
   INY
   JSR GETRYPE
   STX TRROM
   INY
   JSR GETRYPE
   STX TRO

   FILERG = *
   JSR INITUTUF
-  JSR STOPKEY
   BCC +
   JMP STOPPED
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   ORA ZP+1
   BEQ MAINXIT
   JSR TRILE
   BCC +
   JSR ERROR
+  INC ARG+0
   BNE +
   INC ARG+1
+  JMP -

MAINXIT = *
   JSR FLUSHUTUF
   RTS

GETRYPE = *  ;( (ZP)+.Y=STR ) : .=TYPE
   LDA (ZP),Y
   INY
   LDX #TRETSCII
   CMP #"P"
   BEQ GETRET
   LDX #TRPEEDSCRIPT
   CMP #"S"
   BEQ GETRET
   LDX #TRSCIIF
   CMP #"U"
   BEQ GETRET
   LDX #TRSCIIRF
   CMP #"M"
   BEQ GETRET
   LDX #TRETSCII
   CMP #"C"
   BEQ GETRET
   CMP #"A"
   BNE USAGE
   LDA (ZP),Y
   INY
   LDX #TRSCIIF
   CMP #"L"
   BEQ GETRET
   LDX #TRSCIIR
   CMP #"C"
   BEQ GETRET
   CMP #"R"
   BEQ GETRET
   DEY
   LDX #TRSCIIRF
   GETRET = *
   CLC
   RTS

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   LDA #1
   JMP EXIT

USAGESG = *
   .ASC "USAGE: TR [-FROMSET2TOSET] FILE ..."
   .BYTE CHR
   .ASC "WHERE FROMSET/TOSET=P,A,AL,AC,S,C,U,M"
   .BYTE CHR
   .ASC "(PETSCII,ASC-CRLF,ASC-LF,ASC-CR,"
   .BYTE CHR
   .ASC " SPEEDSCRIPT,COMMODORE,UNIX,MS-DOS)"
   .BYTE CHR,0

STOPPED = *
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

ERROR = *
   LDA #<ERRORSG1
   LDY #>ERRORSG1
   JSR EPUTS
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<ERRORSG2
   LDY #>ERRORSG2
   JMP EPUTS
   ERRORSG1 = *
   .ASC "RROR READING FILE "
   .BYTE CHRUOTE,0
   ERRORSG2 = *
   .BYTE CHRUOTE,CHR,0

BUFTR     = 10 ;(2)
BUFOUNT   = 12 ;(2)
INFILE     = 14 ;(1)
INUFEN   = 16 ;(2)
READRAB  = 18 ;(2)
WRITERAB = 20 ;(2)
OUTUFOUNT = 22 ;(1)

TRILE = *
   JSR INITR
   JSR INITNUF
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   JSR TRODY
   LDA INFILE
   JSR CLOSE
   RTS

TRODY = *
   JSR GETYTE
   BCS BODYXIT
   LDX TRROM
   BEQ BODYRITE
   CMP #13
   BNE +
   CPX #TRSCIIRF
   BEQ TRODY
   CPX #TRSCIIR
   BEQ BODYRITE
+  TAY
   LDA (READRAB),Y

   BODYRITE = *
   LDX TRO
   BEQ BODYEP
   CMP #13
   BNE +
   CPX #TRPEEDSCRIPT
   BEQ +
   CPX #TRSCIIR
   BEQ BODYEP
   CPX #TRSCIIF
   BEQ +
   JSR PUTYTE
   LDA #13
+  TAY
   LDA (WRITERAB),Y

   BODYEP = *
   JSR PUTYTE
   JMP TRODY

   BODYXIT = *
   RTS

GETYTE = *
   LDA BUFOUNT+0
   ORA BUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (BUFTR),Y
   INC BUFTR+0
   BNE +
   INC BUFTR+1
+  LDX BUFOUNT+0
   BNE +
   DEC BUFOUNT+1
+  DEC BUFOUNT+0
   CLC
   RTS

GETYTEILLUF = *
   JSR STOPKEY
   BCC +
   JSR STOPPED
+  LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   STA BUFTR+0
   STY BUFTR+1
   LDA INUFEN+0
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT+0
   STY BUFOUNT+1
   JMP GETYTE
+  SEC
   RTS

INITNUF = *
   SEC
   LDA ACEEMOP+0
   SBC #<INUF
   STA INUFEN+0
   LDA ACEEMOP+1
   SBC #>INUF
   STA INUFEN+1
   LDA #0
   STA BUFOUNT+0
   STA BUFOUNT+1
   LDX #STDOUT
   JSR DEVINFO
   CMP #0
   BNE +
   LDA #<254
   LDY #>254
   STA INUFEN+0
   STY INUFEN+1
+  RTS

PUTYTE = *
   LDX OUTUFOUNT
   CPX #254
   BCC +
   PHA
   JSR FLUSHUTUF
   PLA
   LDX OUTUFOUNT
+  STA OUTUF,X
   INC OUTUFOUNT
   RTS

FLUSHUTUF = *
   JSR STOPKEY
   BCC +
   JMP STOPPED
+  LDA #<OUTUF
   LDY #>OUTUF
   STA ZP+0
   STY ZP+1
   LDA OUTUFOUNT
   LDY #0
   LDX #STDOUT
   JSR WRITE
   LDA #0
   STA OUTUFOUNT
   RTS

INITUTUF = *
   LDA #0
   STA OUTUFOUNT
   RTS

INITR = *
   LDA TRROM
   ASL
   TAX
   LDA READR,X
   STA READRAB+0
   LDA READR+1,X
   STA READRAB+1
   LDA TRO
   ASL
   TAX
   LDA WRITER,X
   STA WRITERAB+0
   LDA WRITER+1,X
   STA WRITERAB+1
   RTS

READR  .WORD 0,ASCOET,ASCOET,ASCOET,SPDOET
WRITER .WORD 0,PETOSC,PETOSC,PETOSC,PETOPD

ASCOET = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $00,$01,$02,$03,$04,$05,$06,$07,$9D,$09,$0D,$0B,$93,$0A,$0E,$0F ;0
.BYTE $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $40,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF ;4
.BYTE $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$5B,$5C,$5D,$5E,$5F ;5
.BYTE $C0,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;6
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$DB,$DC,$DD,$DE,$DF ;7
.BYTE $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F ;8
.BYTE $90,$91,$92,$0C,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$08,$9E,$9F ;9
.BYTE $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF ;A
.BYTE $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF ;B
.BYTE $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F ;C
.BYTE $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F ;D
.BYTE $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF ;E
.BYTE $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF ;F

SPDOET = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;0
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$0D ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF ;4
.BYTE $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF ;5
.BYTE $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF ;6
.BYTE $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF ;7
.BYTE $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$5F,$0E,$0F ;8
.BYTE $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F ;9
.BYTE $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF ;A
.BYTE $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF ;B
.BYTE $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F ;C
.BYTE $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F ;D
.BYTE $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F ;E
.BYTE $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F ;F

PETOSC = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0D,$0B,$93,$0A,$0E,$0F ;0
.BYTE $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $40,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F ;4
.BYTE $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$5B,$5C,$5D,$5E,$5F ;5
.BYTE $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF ;6
.BYTE $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF ;7
.BYTE $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F ;8
.BYTE $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F ;9
.BYTE $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF ;A
.BYTE $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF ;B
.BYTE $60,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;C
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$7B,$7C,$7D,$7E,$7F ;D
.BYTE $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF ;E
.BYTE $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF ;F

PETOPD = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$1F,$8E,$8F ;0
.BYTE $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F ;4
.BYTE $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$8D ;5
.BYTE $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF ;6
.BYTE $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF ;7
.BYTE $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF ;8
.BYTE $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF ;9
.BYTE $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F ;A
.BYTE $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F ;B
.BYTE $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;C
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F ;D
.BYTE $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF ;E
.BYTE $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF ;F

;===BSS===

BSS     = *
OUTUF  = BSS
INUF   = OUTUF+256
