UNBCODE = *
   ;** OPEN FILE
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   ;** DECODE FILE
   JSR UNBCODEODY
   ;** CLOSE FILE
   LDA INFILE
   JSR CLOSE
   RTS

UNBCODEODY = *
   LDA #0
   STA BUFOUNT+0
   STA BUFOUNT+1
   STA HITASTINE
   STA LASTINEERMINATOR

   ;** SEARCH FOR "BEGIN" LINE
   SEARCHINE = *
   JSR GETLINE
   BCC +
   CLC
   RTS
+  LDA ININE
   CMP #"-"
   BNE SEARCHINE
   JSR CHECKTOP
   LDX #0
   LDA ININE+2
   CMP #"B"
   BEQ +
   LDX #ASCIIEGIN-PETSCIIEGIN
+  LDY #0
-  LDA ININE,Y
   CMP PETSCIIEGIN,X
   BNE SEARCHINE
   INX
   INY
   CPY #ASCIIEGIN-PETSCIIEGIN
   BCC -
   LDY #0
   CPX #ASCIIEGIN-PETSCIIEGIN+1
   BCC +
   LDY #$FF
+  STY ASCIIILE
   JMP PROCESSEGIN

   PETSCIIEGIN = *
   .ASC "--BCODE-BEGIN "
   ASCIIEGIN = *
   .BYTE $2D,$2D,$62,$63,$6F,$64,$65,$2D,$62,$65,$67,$69,$6E,$20
   
   ;** PROCESS "BEGIN" LINE
   PROCESSEGIN = *
   ;** EXTRACT THE SEGMENT NUMBER
   LDY #14
   JSR SCANUM
   BCC +
   JMP BEGINRROR
+  INY
   LDA SCANAL+2
   ORA SCANAL+3
   BEQ +
   LDA #<SEGOOIGSG
   LDY #>SEGOOIGSG
   JSR EPUTS
   JMP SEARCHINE
+  LDA SCANAL+0
   LDX SCANAL+1
   STA SEGNUM+0
   STX SEGNUM+1
   LDA #0
   STA SEGNUM+2
   STA SEGNUM+3
   LDA SEGNUM+0
   ORA SEGNUM+1
   BNE +
   JMP BEGINRROR

   ;** EXTRACT FILENAME, TRUNC TO 16 CHARS
+  CLC
   TYA
   ADC #<ININE
   STA OUTAME+0
   LDA #>ININE
   ADC #0
   STA OUTAME+1
   LDY #16
   LDA #0
   STA (OUTAME),Y
   JSR MAKEETSCIIAME
   JSR ECHOXTRACTAME

   ;** OPEN OUTPUT FILE
   JSR GETEMPILE
   BCC +
   JMP SEARCHINE

   ;** READ BCODED DATA
+  JSR BUILDECODEABLE
   JSR CRCNIT
-  JSR GETLINE
   BCS UNEXPECTEDOF
   JSR CONVERTINE
   BCC +
   ;** CHECK IF SEGMENT-END LINE
   LDA ININE
   CMP #"-"
   BEQ FINISHILE
   ;** REPORT INVALID CHARACTERS
   LDA #<BADHARSSG
   LDY #>BADHARSSG
   JSR EPUTS
   JMP -
+  JSR CRUNCHINE
   JSR CRCINE
   JSR WRITEINE
   JMP -

   ;** FINISH WITH FILE
   FINISHILE = *
   LDA OUTFILE
   JSR CLOSE
   JSR CRCINISH
   JSR PROCESSINISH
   ;** PROCESS FOR ANOTHER FILE
   JMP SEARCHINE

UNEXPECTEDOF = *
   LDA #<UNEXOFSG
   LDY #>UNEXOFSG
   JSR EPUTS
   LDA OUTFILE
   JSR CLOSE
   JSR DISCARDEGMENT
   SEC
   RTS

UNEXOFSG = *
   .ASC "UNEXPECTED , IGNORING SEGMENT."
   .BYTE CHR,0

SEGOOIGSG = *
   .ASC "SEGMENT NUMBER IS LARGER THAN 65535, IGNORING SEGMENT."
   .BYTE CHR,0

BADHARSSG = *
   .ASC "WARNING: BAD CHARACTERS ON LINE, IGNORING LINE."
   .BYTE CHR,0

MAKEETSCIIAME = *
   BIT ASCIIILE
   BMI +
   RTS
+  LDY #0
-  LDA (OUTAME),Y
   BEQ +
   JSR CONVSC2ET
   STA (OUTAME),Y
   INY
   BNE -
+  RTS

CONVSC2ET = *
   AND #$7F
   CMP #$60
   BCC +
   CLC
   ADC #$C0-$60
+  TAX
   AND #$7F
   CMP #"A"
   BCS +
-  TXA
   RTS
+  CMP #"Z"+1
   BCS -
   TXA
   EOR #$80
   RTS

ECHOXTRACTAME = *
   LDA #<ECHOXTRACTSG1
   LDY #>ECHOXTRACTSG1
   JSR EPUTS
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   LDA #1
   LDX #SEGNUM
   JSR UTOA
   LDA #<NUMBUF
   LDY #>NUMBUF
   JSR EPUTS
   LDA #<ECHOXTRACTSG2
   LDY #>ECHOXTRACTSG2
   JSR EPUTS
   LDA OUTAME+0
   LDY OUTAME+1
   JSR EPUTS
   LDA #<ECHOXTRACTSG3
   LDY #>ECHOXTRACTSG3
   JMP EPUTS

ECHOXTRACTSG1 = *
   .ASC "EXTRACTING SEG "
   .BYTE 0
ECHOXTRACTSG2 = *
   .ASC " OF "
   .BYTE CHRUOTE,0
ECHOXTRACTSG3 = *
   .BYTE CHRUOTE,CHR,0
NUMBUF .BUF 12

REPORTPENRROR = *
   LDA ZP+0
   LDY ZP+1
   JSR EPUTS
   LDA #<REPORTPENRRORSG
   LDY #>REPORTPENRRORSG
   JSR EPUTS
   RTS

   REPORTPENRRORSG = *
   .ASC ": CANNOT OPEN, CONTINUING"
   .BYTE CHR,0

SCANIGIT .BUF 1
SCANAVE .BUF 4
SCANEMP .BUF 1
SCANNDEX .BUF 1
SCANNYTHING .BUF 1

SCANUM = *  ;( .=ININENDEX ) : .=SCAN, [SCANAL]=NUM, .=ERR
   LDX #3
   LDA #0
-  STA SCANAL,X
   DEX
   BPL -
   LDA #0
   STA SCANNYTHING
-  LDA ININE,Y
   CMP #" "
   BNE SCANUMEXT
   INY
   BNE -
   SEC
   RTS

   SCANUMEXT = *
   LDA ININE,Y
   CMP #"0"
   BCC +
   CMP #"9"+1
   BCC ++
+  LDA SCANNYTHING
   BEQ SCANRROR
   CLC
   RTS
+  AND #$0F
   STA SCANIGIT
   LDA #$FF
   STA SCANNYTHING
   ;** TIMES TEN
   STY SCANEMP
   LDX #3
-  LDA SCANAL,X
   STA SCANAVE,X
   DEX
   BPL -
   LDA #2
   STA SCANNDEX
-  CLC
   LDY #4
   LDX #0
-  ROL SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   DEC SCANNDEX
   BNE --
   CLC
   LDY #4
   LDX #0
-  LDA SCANAL,X
   ADC SCANAVE,X
   STA SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   CLC
   LDY #4
   LDX #0
-  ROL SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   CLC
   LDY #4
   LDX #0
   LDA SCANIGIT
-  ADC SCANAL,X
   STA SCANAL,X
   LDA #0
   INX
   DEY
   BNE -
   BCS SCANRROR

   LDY SCANEMP
   INY
   BEQ SCANRROR
   JMP SCANUMEXT

   SCANRROR = *
   SEC
   RTS
   
BEGINRROR = *
   LDA #<BEGINRRORSG
   LDY #>BEGINRRORSG
   JSR EPUTS
   JMP SEARCHINE

BEGINRRORSG = *
   .ASC "INVALID --BCODE-BEGIN LINE FORMAT, IGNORING SEGMENT"
   .BYTE CHR,0

CONVERTADS .BUF 1
CONVERTHARS .BUF 1

CONVERTINE = *
   LDX #0
   STX CONVERTADS
-  LDA ININE,X
   BNE +
   STX CONVERTHARS
   CLC
   RTS
+  CMP #"="
   BNE +
   INC CONVERTADS
+  TAY
   LDA DECODEABLE,Y
   BMI +
   STA ININE,X
   INX
   BNE -
+  SEC
   RTS

CRUNCHYTES .BUF 1

CRUNCHINE = *
   LDX #0
   LDY #0
-  JSR CRUNCHUANTUM
   CPX CONVERTHARS
   BCC -
   TYA
   SEC
   SBC CONVERTADS
   STA CRUNCHYTES
   RTS

;POS  76543210  76543210  76543210  76543210
;BYT  XX111111  XX112222  XX222233  XX333333
;BIT    765432    107654    321076    543210

CRUNCHUANTUM = * ;(.=N4BYTESFFSET, .=UT3BYTESFFSET) : .++, .++
   LDA ININE,X  ;*** OUTPUT BYTE 0
   ASL
   ASL
   STA TEMP
   INX
   LDA ININE,X
   LSR
   LSR
   LSR
   LSR
   AND #%00000011
   ORA TEMP
   STA ININE,Y
   INY
   LDA ININE,X  ;*** OUTPUT BYTE 1
   ASL
   ASL
   ASL
   ASL
   STA TEMP
   INX
   LDA ININE,X
   LSR
   LSR
   AND #%00001111
   ORA TEMP
   STA ININE,Y
   INY
   LDA ININE,X  ;*** OUTPUT BYTE 2
   INX
   ROR
   ROR
   ROR
   AND #%11000000
   STA TEMP
   LDA ININE,X
   INX
   AND #%00111111
   ORA TEMP
   STA ININE,Y
   INY
   RTS

WRITEINE = *
   LDA #<ININE
   LDY #>ININE
   STA ZP+0
   STY ZP+1
   LDA CRUNCHYTES
   LDY #0
   LDX OUTFILE
   JSR WRITE
   RTS

;** CRC = 0X;
;** WHILE( (C=GETC(FP)) !=  ) 
;**     CRC = (CRC>>8) & 0X00 ^ CRCABLE[ (CRC^C) & 0X ];
;** 
;** RETURN( CRC^0X );

CRCNIT = *
   LDX #3
-  LDA #$FF
   STA CRC,X
   LDA #0
   STA BYTES,X
   DEX
   BPL -
   RTS

CRCINE = *
   LDY #0
   CPY CRUNCHYTES
   BCS +
-  LDA ININE,Y         ;. = (CRC^C) & 0X
   EOR CRC+0
   TAX
   LDA CRC+1            ;CRC = (CRC>>8) & 0X00 ^ CRCABLE[ . ]
   EOR CRCABLE0,X
   STA CRC+0
   LDA CRC+2
   EOR CRCABLE1,X
   STA CRC+1
   LDA CRC+3
   EOR CRCABLE2,X
   STA CRC+2
   LDA CRCABLE3,X
   STA CRC+3
   INY
   CPY CRUNCHYTES
   BCC -
+  CLC
   LDA BYTES+0
   ADC CRUNCHYTES
   STA BYTES+0
   BCC +
   INC BYTES+1
   BNE +
   INC BYTES+2
   BNE +
   INC BYTES+3
+  RTS

CRCINISH = *
   LDX #3
-  LDA CRC,X
   EOR #$FF
   STA CRC,X
   DEX
   BPL -
   RTS

HITASTINE .BUF 1
LASTINEERMINATOR .BUF 1

GETLINE = *
   LDA HITASTINE
   BEQ +
   SEC
   RTS
+  LDX #0
   STX GETLINEOS

   ;** TOSS AN  THAT FOLLOWS A 
   JSR GETYTE
   BCS GETLINEROCESS
   CMP #CHR
   CLC
   BNE GETLINEROCESS
   LDX LASTINEERMINATOR
   CPX #CHR
   CLC
   BNE GETLINEROCESS

   GETLINEHAR = *
   JSR GETYTE
   GETLINEROCESS = *
   BCC +
   LDA #$FF
   STA HITASTINE
   JMP GETLINEINISH
+  CMP #CHR
   BEQ GETLINEINISH
   CMP #CHR
   BEQ GETLINEINISH
   LDX GETLINEOS
   CPX #98
   BCS +
   STA ININE,X
   INC GETLINEOS
+  JMP GETLINEHAR

   GETLINEINISH = *
   STA LASTINEERMINATOR
   LDX GETLINEOS
   LDA #0
   STA ININE,X
   CPX #0
   BEQ +
   CLC
   RTS
+  LDA HITASTINE
   CMP #1
   RTS

GETYTE = *
   LDA BUFOUNT+0
   ORA BUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (BUFTR),Y
   INC BUFTR+0
   BNE +
   INC BUFTR+1
+  LDX BUFOUNT+0
   BNE +
   DEC BUFOUNT+1
+  DEC BUFOUNT+0
   CLC
   RTS

GETYTEILLUF = *
   JSR CHECKTOP
   LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   STA BUFTR+0
   STY BUFTR+1
   LDA INUFEN+0
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT+0
   STY BUFOUNT+1
   JSR CHECKTOP
   JMP GETYTE
+  SEC
   RTS

SETNDEX .BUF 1
SETOUNTDOWN .BUF 1

BUILDECODEABLE = *
   LDX #0
   LDA #$FF
-  STA DECODEABLE,X
   INX
   BNE -
   LDY #0
   LDX #0
   BIT ASCIIILE
   BPL +
   LDX #ASCABLEET-PETABLEET
+  STX SETNDEX
   LDA #5
   STA SETOUNTDOWN
-  LDX SETNDEX
   LDA PETABLEET+1,X
   STA TEMP
   LDA PETABLEET+0,X
   INX
   INX
   STX SETNDEX
   LDX TEMP
   JSR BUILDET
   DEC SETOUNTDOWN
   BNE -
   LDA #0
   STA DECODEABLE+$3D
   RTS

PETABLEET .ASC "AZ09++//"
ASCABLEET .BYTE $41,$5A,$61,$7A,$30,$39,$2B,$2B,$2F,$2F

SETIMIT .BUF 1

BUILDET = *
   INX
   STX SETIMIT
   TAX
-  TYA
   STA DECODEABLE,X
   INY
   INX
   CPX SETIMIT
   BCC -
   RTS

PROCESSINISH = *  ;PROCESS THE BCODE-END LINE
   LDA #TRUE
   STA ISND
   LDX #ASCND-PETND-1
   BIT ASCIIILE
   BPL +
   LDX #PETONT-PETND-1
+  LDY #ASCND-PETND-1
   JSR COMPAREINISH
   LDY #ASCND-PETND-1
   BCC FINHECKEGMENT
   LDA #FALSE
   STA ISND
   LDX #ASCONT-PETND-1
   BIT ASCIIILE
   BPL +
   LDX #ASCONTND-PETND-1
+  LDY #ASCONT-PETONT-1
   JSR COMPAREINISH
   LDY #ASCONT-PETONT
   BCC FINHECKEGMENT
   LDA #0
   JMP BADINISH

   FINHECKEGMENT = *
   JSR SCANUM
   BCC +
-  LDA #1
   JMP BADINISH
+  LDX #3
-  LDA SCANAL,X
   CMP SEGNUM,X
   BNE --
   DEX
   BPL -

   FINHECKIZE = *
   JSR SCANUM
   BCC +
-  LDA #2
   JMP BADINISH
+  LDX #3
-  LDA SCANAL,X
   CMP BYTES,X
   BNE --
   DEX
   BPL -
   
   FINHECKRC = *
   INY
   JSR SCANEX
   BCC +
-  LDA #3
   JMP BADINISH
+  LDX #3
-  LDA SCANAL,X
   CMP CRC,X
   BNE --
   DEX
   BPL -
   JSR COMMITEGMENT
   BIT DEBUG
   BPL +
   LDX #STDERR
   STX STATCB
   JSR WRITETATUSATA
+  JSR CHECKTOP
   CLC
   RTS

SCANEX = *
   LDX #3
-  LDA ININE,Y
   INY
   JSR HEXOIN
   BCS +
   ASL
   ASL
   ASL
   ASL
   STA TEMP
   LDA ININE,Y
   INY
   JSR HEXOIN
   BCS +
   ORA TEMP
   STA SCANAL,X
   DEX
   BPL -
   CLC
+  RTS

HEXOINSAVE .BUF 1

HEXOIN = *
   BIT ASCIIILE
   BPL +
   STX HEXOINSAVE
   JSR CONVSC2ET
   LDX HEXOINSAVE
+  CMP #"0"
   BCS +
-  SEC
   RTS
+  CMP #"9"+1
   BCC +
   AND #$7F
   CMP #"A"
   BCC -
   CMP #"F"+1
   BCS -
   SEC
   SBC #"A"-$0A
+  AND #$0F
   CLC
   RTS

COMPAREINISH = *
-  LDA ININE,Y
   CMP PETND,X
   BNE +
   DEX
   DEY
   BPL -
   CLC
   RTS
+  SEC
   RTS

BADINISH = *  ;.=ERROR [0=TOKEN,1=SEGMENT,2=SIZE,3=CRC]
   PHA
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   PLA
   ASL
   TAX
   LDA BADINEC+1,X
   TAY
   LDA BADINEC+0,X
   JSR EPUTS
   LDA #<BADINISCARD
   LDY #>BADINISCARD
   JSR EPUTS
   JSR DISCARDEGMENT
   JSR CHECKTOP
   RTS

BADINEC = *
   .WORD BADINOKEN,BADINEGMENT,BADINIZE,BADINRC
BADINOKEN = *
   .ASC ": INVALID TOKEN ON FINISH LINE"
   .BYTE 0
BADINEGMENT = *
   .ASC ": SEGMENT NUMBER MISMATCH"
   .BYTE 0
BADINIZE = *
   .ASC ": FILE SIZE MISMATCH"
   .BYTE 0
BADINRC = *
   .ASC ": -32 CHECKSUM MISMATCH"
   .BYTE 0
BADINISCARD = *
   .ASC ", IGNORING SEGMENT"
   .BYTE CHR,0

PETND .ASC "--BCODE-END "
ASCND .BYTE $2D,$2D,$62,$63,$6F,$64,$65,$2D,$65,$6E,$64,$20

PETONT .ASC "--BCODE-CONTINUED "
ASCONT .BYTE $2D,$2D,$62,$63,$6F,$64,$65,$2D,$63,$6F,$6E,$74,$69,$6E,$75
        .BYTE $65,$64,$20
ASCONTND = *

GETEMPAMETR = *  ;( TEMPAME, .=PUTILETYPE ) : TEMPAMETR, (ZP)
   PHA
   LDA #"0"
   STA TEMPAMETR+0
   LDA #""
   STA TEMPAMETR+1
   LDA #""
   STA TEMPAMETR+2
   LDA #<TEMPAMETR+3
   LDY #>TEMPAMETR+3
   STA ZP+0
   STY ZP+1
   LDX #TEMPAME
   LDA #5
   JSR UTOAZ
   PLA
   CMP #FALSE
   BEQ +
   LDA #","
   STA TEMPAMETR+3,Y
   LDA #"P"
   STA TEMPAMETR+4,Y
   LDA #0
   STA TEMPAMETR+5,Y
+  RTS

UTOAZ = *  ;( 0+.=VAR32, .=WIDTH, (ZP)=STORE )
   JSR UTOA
   LDY #0
-  LDA (ZP),Y
   BEQ ++
   CMP #" "
   BNE +
   LDA #"0"
   STA (ZP),Y
+  INY
   BNE -
+  RTS

FILEODE .BUF 1

GETEMPILE = *  ;( OUTAME, SEGNUM ) : CURAVE, CURAVEUM, OUTFILE, .=ERR
   ;** SEARCH TO APPEND TO EXISTING FILE
   LDA #255
   STA CURAVE

   CHECKEXT = *
   INC CURAVE
   LDA CURAVE
   CMP HAVEOUNT
   BCC +
   JMP CANNOTPPEND
+  JSR GET
   JSR CMPUTAME
   CMP #0
   BNE CHECKEXT
   LDY #HRROMEG
   LDA SEGNUM+0
   CMP (H),Y
   LDA SEGNUM+1
   INY
   SBC (H),Y
   BCC +
   LDY #HROEG
   LDA (H),Y
   CMP SEGNUM+0
   INY
   LDA (H),Y
   SBC SEGNUM+1
   BCC +
   LDA #<IGNOREUPSG
   LDY #>IGNOREUPSG
   JSR EPUTS
   SEC
   RTS
   IGNOREUPSG = *
   .ASC "IGNORING DUPLICATE SEGMENT"
   .BYTE CHR,0

+  LDY #HROEG
   LDA (H),Y
   TAX
   INY
   LDA (H),Y
   TAY
   INX
   BNE +
   INY
+  CPX SEGNUM+0
   BNE +
   CPY SEGNUM+1
   BEQ CANPPEND
+  JMP CHECKEXT

   ;** HERE WE KNOW WE CAN APPEND TO AN EXISTING TEMP FILE
   CANPPEND = *
   LDA #"A"
   STA FILEODE
   LDY #HREMPILEAME
   LDA (H),Y
   STA TEMPAME+0
   INY
   LDA (H),Y
   STA TEMPAME+1
   LDY #HROEG
   LDA SEGNUM+0
   STA (H),Y
   INY
   LDA SEGNUM+1
   STA (H),Y
   LDY #HRSND
   LDA #FALSE
   STA (H),Y
   JMP OPENEMPILE

   ;** CANNOT APPEND
   CANNOTPPEND = *
   JSR GETEMPILEAMENLY

   ;** CREATE NEW HAVE RECORD
   CREATEEWAVEEC = *
   JSR INSERTAVEEC
   BCS +
   LDA #"W"
   STA FILEODE
   JMP OPENEMPILE
+  LDA #<HAVEVERSG
   LDY #>HAVEVERSG
   JSR EPUTS
   SEC
   RTS
   HAVEVERSG = *
   .ASC "FRAGMENT TABLE FULL, IGNORING CURRENT SEGMENT"
   .BYTE CHR,0

   ;** OPEN TEMPORARY FILE
   OPENEMPILE = *
   LDA #TRUE
   JSR GETEMPAMETR
   LDA #<TEMPAMETR
   LDY #>TEMPAMETR
   STA ZP+0
   STY ZP+1
   LDA FILEODE
   JSR OPENVERWRITE
   BCS +
   STA OUTFILE
   CLC
   RTS
+  LDA #<TEMPAMETR
   LDY #>TEMPAMETR
   JSR EPUTS
   LDA #<OPENRRSG
   LDY #>OPENRRSG
   JSR EPUTS
   SEC
   RTS
   OPENRRSG = *
   .ASC ": CANNOT OPEN, IGNORING SEGMENT"
   .BYTE CHR,0

GETEMPILEAMENLY = *  ;( NEXTEMPAME ) : TEMPAME
   LDA NEXTEMPAME+0
   LDY NEXTEMPAME+1
   STA TEMPAME+0
   STY TEMPAME+1
   INC NEXTEMPAME+0
   BNE +
   INC NEXTEMPAME+1
+  LDA #0
   STA WORK
-  CMP HAVEOUNT
   BCC +
   RTS
+  LDA WORK
   JSR GET
   LDY #HREMPILEAME
   LDA (H),Y
   CMP TEMPAME+0
   BNE +
   INY
   LDA (H),Y
   CMP TEMPAME+1
   BNE +
   JMP GETEMPILEAMENLY
+  INC WORK
   LDA WORK
   JMP -

GET = *  ;( .=HAVEECUM ) : H
   LDX #0
   STX H+1
   LDX #5
-  ASL
   ROL H+1
   DEX
   BNE -
   CLC
   ADC #<HAVES
   STA H+0
   LDA H+1
   ADC #>HAVES
   STA H+1
   RTS

GETEXT = *  ;( H ) : NEXT
   CLC
   LDA H+0
   ADC #HRIZE
   STA NEXT+0
   LDA H+1
   ADC #0
   STA NEXT+1
   RTS

CMPUTAME = *  ;( (OUTAME)=STR1, (H)=HREC ) : .=CMPESULT[0=,1=,-1=]
   LDA H+0
   LDY H+1
   CLC
   ADC #HRILENAME
   BCC +
   INY
+  STA WORK+0
   STY WORK+1
   LDY #255
-  INY
   LDA (OUTAME),Y
   CMP (WORK),Y
   BNE +
   CMP #0
   BNE -
   LDA #0
   RTS
+  BCC +
   LDA #1
   RTS
+  LDA #$FF
   RTS

INSERTAVEEC = *  ;( SEGNUM, TEMPAME, OUTAME ) : CURAVE
   ;** ALLOCATE NEW RECORD
   LDA HAVEOUNT
   CMP #MAXAVE
   BCC +
   RTS
+  STA CURAVE
   INC HAVEOUNT

   ;** FIND CORRECT POSITION FOR NEW RECORD
-  DEC CURAVE
   LDA CURAVE
   CMP #$FF
   BEQ INSERTAVEECNIT
   JSR GET
   JSR CMPUTAME
   CMP #1
   BEQ INSERTAVEECNIT
   CMP #0
   BNE +
   LDY #HRROMEG
   LDA (H),Y
   CMP SEGNUM+0
   INY
   LDA (H),Y
   SBC SEGNUM+1
   BCC INSERTAVEECNIT
+  JSR GETEXT
   LDY #HRIZE-1
-  LDA (H),Y
   STA (NEXT),Y
   DEY
   BPL -
   JMP --

   ;** INITIALIZE RECORD
   INSERTAVEECNIT = *
   INC CURAVE
   LDX #HRIZE-1
   LDA #0
-  STA TEMPAVEEC,X
   DEX
   BPL -
   LDA SEGNUM+0
   LDY SEGNUM+1
   STA TEMPAVEEC+HRROMEG+0
   STY TEMPAVEEC+HRROMEG+1
   STA TEMPAVEEC+HROEG+0
   STY TEMPAVEEC+HROEG+1
   LDA #FALSE
   STA TEMPAVEEC+HRSND
   LDA TEMPAME+0
   LDY TEMPAME+1
   STA TEMPAVEEC+HREMPILEAME+0
   STY TEMPAVEEC+HREMPILEAME+1
   LDY #0
-  LDA (OUTAME),Y
   STA TEMPAVEEC+HRILENAME,Y
   BEQ +
   INY
   CPY #16
   BCC -
+  LDA CURAVE
   JSR GET
   LDY #HRIZE-1
-  LDA TEMPAVEEC,Y
   STA (H),Y
   DEY
   BPL -
   CLC
   RTS

WRITEUM5 = *  ;( 0+.=NUM16 )
   LDA 0,X
   STA WORK+12
   LDA 1,X
   STA WORK+13
   LDA #0
   STA WORK+14
   STA WORK+15
   LDX #WORK+12
   LDA #5
   JMP WRITEUM

WRITEUM10 = *  ;( 0+.=NUM32 )
   LDA #10
WRITEUM = *
   PHA
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   PLA
   JSR UTOAZ
   LDA #<NUMBUF
   LDY #>NUMBUF
   LDX STATCB
   JSR FPUTS
   JSR WRITEPACES
   RTS

WRITEPACES = *
   LDA #<SPACESSG
   LDY #>SPACESSG
   LDX STATCB
   JSR FPUTS
   RTS
   SPACESSG = *
   .BYTE $20,$20,0

COMMITEGMENT = *
   ;** ADD BYTE LENGTH, UPDATE SND FLAG IN HAVEREC
   LDA CURAVE
   JSR GET
   LDX #4
   LDY #HRALIDENGTH
   CLC
-  LDA (H),Y
   ADC BYTES-HRALIDENGTH,Y
   STA (H),Y
   INY
   DEX
   BNE -
   LDY #HRSND
   LDA ISND
   STA (H),Y
   JSR CHECKOALESCE
   JSR CHECKOMPLETE
   RTS

CHECKILENAMETR .BUF 2

CHECKOMPLETE = *
   LDA CURAVE
   JSR GET
   LDY #HRSND
   LDA (H),Y
   BNE +
-  RTS
+  LDY #HRROMEG
   LDA (H),Y
   CMP #1
   BNE -
   INY
   LDA (H),Y
   BNE -
   JSR FETCHEMPAME
   LDA #FALSE
   JSR GETEMPAMETR
   LDA #<TEMPAMETR
   LDY #>TEMPAMETR
   STA ZP+0
   STY ZP+1
   LDA H+0
   LDY H+1
   CLC
   ADC #HRILENAME
   BCC +
   INY
+  STA ZW+0
   STY ZW+1
   STA CHECKILENAMETR+0
   STY CHECKILENAMETR+1
   JSR RENAMEVERWRITE
   LDA #<COMPLETESG1
   LDY #>COMPLETESG1
   JSR EPUTS
   LDA CHECKILENAMETR+0
   LDY CHECKILENAMETR+1
   JSR EPUTS
   LDA #<COMPLETESG2
   LDY #>COMPLETESG2
   JSR EPUTS
   LDA CURAVE
   JSR REMOVEAVEEC
   RTS

COMPLETESG1 = *
   .ASC "--EASSEMBLED "
   .BYTE CHRUOTE,0
COMPLETESG2 = *
   .BYTE CHRUOTE,CHR,0

REMOVEAVEEC = *  ;( .=HAVEEC )
   DEC HAVEOUNT
   STA HAVEEC
-  LDA HAVEEC
   CMP HAVEOUNT
   BCC +
   RTS
+  LDA HAVEEC
   JSR GET
   JSR GETEXT
   LDY #HRIZE-1
-  LDA (NEXT),Y
   STA (H),Y
   DEY
   BPL -
   INC HAVEEC
   JMP --

CHECKROMLUS1 .BUF 2

CHECKOALESCE = *  ;( CURAVE )
   LDX CURAVE
   INX
   CPX HAVEOUNT
   BCC +
-  RTS
+  LDA CURAVE
   JSR GET
   JSR GETEXT
   CLC
   LDA NEXT+0
   ADC #HRILENAME
   STA OUTAME+0
   LDA NEXT+1
   ADC #0
   STA OUTAME+1
   JSR CMPUTAME
   CMP #0
   BNE -
   LDY #HROEG
   CLC
   LDA (H),Y
   ADC #1
   STA CHECKROMLUS1+0
   INY
   LDA (H),Y
   ADC #0
   STA CHECKROMLUS1+1
   LDY #HRROMEG
   LDA (NEXT),Y
   CMP CHECKROMLUS1+0
   BNE -
   INY
   LDA (NEXT),Y
   CMP CHECKROMLUS1+1
   BNE -

   LDA #<COALESCESG1
   LDY #>COALESCESG1
   JSR EPUTS
   LDA H+0
   LDY H+1
   JSR EPUTANGE
   LDA #","
   JSR EPUTCHAR
   LDA #" "
   JSR EPUTCHAR
   LDA NEXT+0
   LDY NEXT+1
   JSR EPUTANGE
   LDA #<COALESCESG2
   LDY #>COALESCESG2
   JSR EPUTS
   CLC
   LDA H+0
   ADC #HRILENAME
   LDY H+1
   BCC +
   INY
+  JSR EPUTS
   LDA #CHRUOTE
   JSR EPUTCHAR
   LDA #CHR
   JSR EPUTCHAR

   LDX CURAVE
   INX
   LDA #"R"
   JSR OPENEMP
   BCC +
   RTS
+  STA FIN
   LDX CURAVE
   LDA #"A"
   JSR OPENEMP
   BCC +
   LDA FIN
   JSR CLOSE
+  STA FOUT
   LDA CURAVE
   JSR GET
   JSR GETEXT
   LDY #HRALIDENGTH+3
   LDX #3
-  LDA (NEXT),Y
   STA BYTES,X
   DEY
   DEX
   BPL -
   JSR COPYILE
   LDA FOUT
   JSR CLOSE
   LDA FIN
   JSR CLOSE
   LDY #HRSND
   LDA (NEXT),Y
   STA (H),Y
   LDY #HROEG
   LDA (NEXT),Y
   STA (H),Y
   INY
   LDA (NEXT),Y
   STA (H),Y
   LDX #4
   LDY #HRALIDENGTH
   CLC
-  LDA (H),Y
   ADC (NEXT),Y
   STA (H),Y
   INY
   DEX
   BNE -
   LDA CURAVE
   CLC
   ADC #1
   JSR GET
   JSR FETCHEMPAME
   LDA #FALSE
   JSR GETEMPAMETR
   LDA #<TEMPAMETR
   LDY #>TEMPAMETR
   STA ZP+0
   STY ZP+1
   JSR REMOVE
   BCC +
   NOP  ;XX ERROR MSG
+  LDA CURAVE
   CLC
   ADC #1
   JSR REMOVEAVEEC
   RTS

COALESCESG1 = *
   .ASC "COALESCING SEGS "
   .BYTE 0
COALESCESG2 = *
   .ASC " OF "
   .BYTE CHRUOTE,0

EPUTANGE = *
   STA WORK+0
   STY WORK+1
   LDY #HRROMEG
   JSR EPUTAVEUM
   LDA #"-"
   JSR EPUTCHAR
   LDY #HROEG

EPUTAVEUM = *
   LDA (WORK),Y
   STA WORK+4
   INY
   LDA (WORK),Y
   STA WORK+5
   LDA #0
   STA WORK+6
   STA WORK+7
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   LDA #1
   LDX #WORK+4
   JSR UTOA
   LDA #<NUMBUF
   LDY #>NUMBUF
   JSR EPUTS
   RTS

FETCHEMPAME = *  ;( H )
   LDY #HREMPILEAME
   LDA (H),Y
   STA TEMPAME+0
   INY
   LDA (H),Y
   STA TEMPAME+1
   RTS

OPENEMP = *  ;( .=HAVEEC, .=MODE ) : .=FCB, .=ERR
   PHA
   TXA
   JSR GET
   JSR FETCHEMPAME
   LDA #TRUE
   JSR GETEMPAMETR
   LDA #<TEMPAMETR
   LDY #>TEMPAMETR
   STA ZP+0
   STY ZP+1
   PLA
   JSR OPEN
   BCC +
   LDA #<TEMPAMETR
   LDY #>TEMPAMETR
   JSR EPUTS
   LDA #<OPENEMPSG
   LDY #>OPENEMPSG
   JSR EPUTS
   SEC
+  RTS

   OPENEMPSG = *
   .ASC ": CANNOT OPEN, SHOULD BE ABLE TO, CONTINUING"
   .BYTE CHR,0

COPYEGEN .BUF 2
           .BYTE $00,$00

COPYILE = *  ;( FIN, FOUT, BYTES-- )
   LDA #<COPYUF
   LDY #>COPYUF
   STA ZP+0
   STY ZP+1
   LDA BYTES+2
   ORA BYTES+3
   BNE +
   LDA BYTES+0
   CMP #<COPYUFIZE
   LDA BYTES+1
   SBC #>COPYUFIZE
   BCS +
   LDA BYTES+0
   LDY BYTES+1
   JMP ++
+  LDA #<COPYUFIZE
   LDY #>COPYUFIZE
+  LDX FIN
   JSR READ
   BEQ +
   STA COPYEGEN+0
   STY COPYEGEN+1
   LDX FOUT
   JSR WRITE
   SEC
   LDY #4
   LDX #0
-  LDA BYTES,X
   SBC COPYEGEN,X
   STA BYTES,X
   INX
   DEY
   BNE -
   LDA BYTES+0
   ORA BYTES+1
   ORA BYTES+2
   ORA BYTES+3
   BNE COPYILE
   RTS
+  LDA BYTES+0
   ORA BYTES+1
   ORA BYTES+2
   ORA BYTES+3
   BNE +
   RTS
+  LDA #<COPYENSG
   LDY #>COPYENSG
   JSR EPUTS
   RTS

   COPYENSG = *
   .ASC "NSUFFICIENT TEMP DATA COALESCED, SHOULDN'T HAPPEN, CONTINUING"
   .BYTE CHR,0

OPENVODE .BUF 1

OPENVERWRITE = *  ;( (ZP)=NAME, .=MODE ) : .=CB, .=ERR
   STA OPENVODE
   JSR OPEN
   BCS +
   RTS
+  LDA ERRNO
   CMP #ACERRILEXISTS
   BEQ +
-  JSR REPORTPENRROR
   SEC
   RTS
+  JSR REMOVE
   LDA OPENVODE
   JSR OPEN
   BCS -
   RTS

RENAMEVAME .BUF 2

RENAMEVERWRITE = *  ;( (ZP)=NAME, (ZW)=NEWAME ) : .=ERR
   JSR RENAME
   BCS +
   RTS
+  LDA ZP+0
   LDY ZP+1
   STA RENAMEVAME+0
   STY RENAMEVAME+1
   LDA ERRNO
   CMP #ACERRILEXISTS
   BEQ +
-  JSR REPORTENAMERROR
   SEC
   RTS
+  LDA ZW+0
   LDY ZW+1
   STA ZP+0
   STY ZP+1
   JSR REMOVE
   LDA RENAMEVAME+0
   LDY RENAMEVAME+1
   STA ZP+0
   STY ZP+1
   JSR RENAME
   BCS -
   RTS

RENAMEVEWAME .BUF 2

REPORTENAMERROR = *
   LDA ZW+0
   LDY ZW+1
   STA RENAMEVEWAME+0
   STY RENAMEVEWAME+1
   LDA #<RENAMERRSG1
   LDY #>RENAMERRSG1
   JSR EPUTS
   LDA RENAMEVAME+0
   LDY RENAMEVAME+1
   JSR EPUTS
   LDA #<RENAMERRSG2
   LDY #>RENAMERRSG2
   JSR EPUTS
   LDA RENAMEVEWAME+0
   LDY RENAMEVEWAME+1
   JSR EPUTS
   LDA #<RENAMERRSG3
   LDY #>RENAMERRSG3
   JSR EPUTS
   RTS

RENAMERRSG1 = *
   .ASC "ANNOT RENAME "
   .BYTE CHRUOTE,0
RENAMERRSG2 = *
   .BYTE CHRUOTE
   .ASC " TO "
   .BYTE CHRUOTE,0
RENAMERRSG3 = *
   .BYTE CHRUOTE
   .ASC ", CONTINUING."
   .BYTE CHR,0

